<?php
/**
 * Weddi ProTheme Customizer
 *
 * @package Weddi_Pro
 */

/**
 * Add postMessage support for site title and description for the Theme Customizer.
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function weddi_pro_sortable_sections( $wp_customize ) {
	$wp_customize->add_panel( 'weddi_pro_sp_sortable', array(
		'title'       => esc_html__( 'Sections', 'weddi-pro' ),
		'priority'    => 150,
	) );

	$default_sections = weddi_pro_get_default_sortable_sections();

	$sortable_options = array();

	$sortable_order = weddi_pro_gtm( 'weddi_pro_ss_order' );

	if ( $sortable_order ) {
		$sortable_options = explode( ',', $sortable_order );
	}

	$sortable_sections = array_unique( $sortable_options + array_keys( $default_sections ) );
		
	foreach ( $sortable_sections as $section ) {
		if ( isset( $default_sections[$section] ) ) {
			// Add sections.
			$wp_customize->add_section( 'weddi_pro_ss_' . $section,
				array(
					'title' => $default_sections[$section],
					'panel' => 'weddi_pro_sp_sortable'
				)
			);
		}
		
		unset($default_sections[$section]);
	}

	if ( count( $default_sections ) ) {
		foreach ($default_sections as $key => $value) {
			// Add new sections.
			$wp_customize->add_section( 'weddi_pro_ss_' . $key,
				array(
					'title' => $value,
					'panel' => 'weddi_pro_sp_sortable'
				)
			);
		}
	}

	// Add hidden section for saving sorted sections.
	Weddi_Pro_Customizer_Utilities::register_option(
		array(
			'settings'          => 'weddi_pro_ss_order',
			'sanitize_callback' => 'sanitize_text_field',
			'label'             => esc_html__( 'Section layout', 'weddi-pro' ),
			'section'           => 'weddi_pro_ss_main_content',
		)
	);
}
add_action( 'customize_register', 'weddi_pro_sortable_sections', 1 );

/**
 * Default sortable sections order
 * @return array
 */
function weddi_pro_get_default_sortable_sections() {
	return $default_sections = array (
		'slider'           => esc_html__( 'Slider', 'weddi-pro' ),
		'wwd'              => esc_html__( 'What We Do', 'weddi-pro' ),
		'hero_content'     => esc_html__( 'Hero Content', 'weddi-pro' ),
		'featured_grid'    => esc_html__( 'Featured Grid', 'weddi-pro' ),
		'testimonial'      => esc_html__( 'Testimonials', 'weddi-pro' ),
		'contact_form'     => esc_html__( 'Contact Form', 'weddi-pro' ),
	);
}
